diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index 83e4e37c78..fb7b8b4a6f 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -43,6 +43,7 @@
 #include "commands/extension.h"
 #include "commands/lockcmds.h"
 #include "commands/matview.h"
+#include "commands/modulecmds.h"
 #include "commands/policy.h"
 #include "commands/portalcmds.h"
 #include "commands/prepare.h"
@@ -85,7 +86,9 @@ static void ProcessUtilitySlow(ParseState *pstate,
 							   ParamListInfo params,
 							   QueryEnvironment *queryEnv,
 							   DestReceiver *dest,
-							   QueryCompletion *qc);
+							   QueryCompletion *qc,
+							   Oid namespaceIdWhenCreatingInModule,
+							   Oid moduleIdWhenCreatingInModule);
 static void ExecDropStmt(DropStmt *stmt, bool isTopLevel);
 
 /*
@@ -147,6 +150,8 @@ ClassifyUtilityCommandAsReadOnly(Node *parsetree)
 		case T_AlterFdwStmt:
 		case T_AlterForeignServerStmt:
 		case T_AlterFunctionStmt:
+		case T_AlterModuleAlterFuncStmt:
+		case T_AlterModuleCreateReplaceFuncStmt:
 		case T_AlterObjectDependsStmt:
 		case T_AlterObjectSchemaStmt:
 		case T_AlterOpFamilyStmt:
@@ -179,6 +184,7 @@ ClassifyUtilityCommandAsReadOnly(Node *parsetree)
 		case T_CreateForeignServerStmt:
 		case T_CreateForeignTableStmt:
 		case T_CreateFunctionStmt:
+		case T_CreateModuleStmt:
 		case T_CreateOpClassStmt:
 		case T_CreateOpFamilyStmt:
 		case T_CreatePLangStmt:
@@ -212,6 +218,8 @@ ClassifyUtilityCommandAsReadOnly(Node *parsetree)
 		case T_ReassignOwnedStmt:
 		case T_RefreshMatViewStmt:
 		case T_RenameStmt:
+		case T_AlterModuleRenameStmt:
+		case T_AlterModuleOwnerStmt:
 		case T_RuleStmt:
 		case T_SecLabelStmt:
 		case T_TruncateStmt:
@@ -525,9 +533,76 @@ ProcessUtility(PlannedStmt *pstmt,
 								context, params, queryEnv,
 								dest, qc);
 	else
+	{
 		standard_ProcessUtility(pstmt, queryString, readOnlyTree,
+								context, params, queryEnv,
+								dest, qc, InvalidOid, InvalidOid /* not in module */);
+	}
+}
+
+/*
+ * ProcessUtilityUsingModule
+ *		similar to ProcessUtility but for when using modules
+ *
+ *	pstmt: PlannedStmt wrapper for the utility statement
+ *	queryString: original source text of command
+ *	readOnlyTree: if true, pstmt's node tree must not be modified
+ *	context: identifies source of statement (toplevel client command,
+ *		non-toplevel client command, subcommand of a larger utility command)
+ *	params: parameters to use during execution
+ *	queryEnv: environment for parse through execution (e.g., ephemeral named
+ *		tables like trigger transition tables).  May be NULL.
+ *	dest: where to send results
+ *	qc: where to store command completion status data.  May be NULL,
+ *		but if not, then caller must have initialized it.
+ *	namespaceId: oid of the schema that the enclosing module for the stmt is in.
+ *	moduleId: oid of the module the stmt is being called in.
+ *
+ * Caller MUST supply a queryString; it is not allowed to pass NULL.
+ * If you really don't have source text, you can pass a constant string,
+ * perhaps "(query not available)".
+ *
+ * Note for users of ProcessUtility_hook: the same queryString may be passed
+ * to multiple invocations of ProcessUtility when processing a query string
+ * containing multiple semicolon-separated statements.  One should use
+ * pstmt->stmt_location and pstmt->stmt_len to identify the substring
+ * containing the current statement.  Keep in mind also that some utility
+ * statements that CREATE MODULE will recurse to ProcessUtility to process
+ * sub-statements to define functions and procedures passing down the same
+ * queryString, stmt_location, and stmt_len that were given for the whole statement.
+ */
+void
+ProcessUtilityUsingModule(PlannedStmt *pstmt,
+						  const char *queryString,
+						  bool readOnlyTree,
+						  ProcessUtilityContext context,
+						  ParamListInfo params,
+						  QueryEnvironment *queryEnv,
+						  DestReceiver *dest,
+						  QueryCompletion *qc,
+						  Oid namespaceId,
+						  Oid moduleId)
+{
+	Assert(IsA(pstmt, PlannedStmt));
+	Assert(pstmt->commandType == CMD_UTILITY);
+	Assert(queryString != NULL);	/* required as of 8.4 */
+	Assert(qc == NULL || qc->commandTag == CMDTAG_UNKNOWN);
+
+	/*
+	 * We provide a function hook variable that lets loadable plugins get
+	 * control when ProcessUtility is called.  Such a plugin would normally
+	 * call standard_ProcessUtility().
+	 */
+	if (ProcessUtility_hook)
+		(*ProcessUtility_hook) (pstmt, queryString, readOnlyTree,
 								context, params, queryEnv,
 								dest, qc);
+	else
+	{
+		standard_ProcessUtility(pstmt, queryString, readOnlyTree,
+										   context, params, queryEnv,
+										   dest, qc, namespaceId, moduleId);
+	}
 }
 
 /*
@@ -549,7 +624,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 						ParamListInfo params,
 						QueryEnvironment *queryEnv,
 						DestReceiver *dest,
-						QueryCompletion *qc)
+						QueryCompletion *qc,
+						Oid namespaceIdWhenCreatingInModule,
+						Oid moduleIdWhenCreatingInModule)
 {
 	Node	   *parsetree;
 	bool		isTopLevel = (context == PROCESS_UTILITY_TOPLEVEL);
@@ -965,7 +1042,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->objtype))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					ExecuteGrantStmt(stmt);
 			}
@@ -978,7 +1057,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->removeType))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					ExecDropStmt(stmt, isTopLevel);
 			}
@@ -991,7 +1072,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->renameType))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					ExecRenameStmt(stmt);
 			}
@@ -1004,7 +1087,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->objectType))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					ExecAlterObjectDependsStmt(stmt, NULL);
 			}
@@ -1017,7 +1102,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->objectType))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					ExecAlterObjectSchemaStmt(stmt, NULL);
 			}
@@ -1030,7 +1117,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->objectType))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					ExecAlterOwnerStmt(stmt);
 			}
@@ -1043,7 +1132,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->objtype))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					CommentObject(stmt);
 				break;
@@ -1056,7 +1147,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 				if (EventTriggerSupportsObjectType(stmt->objtype))
 					ProcessUtilitySlow(pstate, pstmt, queryString,
 									   context, params, queryEnv,
-									   dest, qc);
+									   dest, qc,
+									   namespaceIdWhenCreatingInModule,
+									   moduleIdWhenCreatingInModule);
 				else
 					ExecSecLabelStmt(stmt);
 				break;
@@ -1066,7 +1159,9 @@ standard_ProcessUtility(PlannedStmt *pstmt,
 			/* All other statement types have event trigger support */
 			ProcessUtilitySlow(pstate, pstmt, queryString,
 							   context, params, queryEnv,
-							   dest, qc);
+							   dest, qc,
+							   namespaceIdWhenCreatingInModule,
+							   moduleIdWhenCreatingInModule);
 			break;
 	}
 
@@ -1093,7 +1188,9 @@ ProcessUtilitySlow(ParseState *pstate,
 				   ParamListInfo params,
 				   QueryEnvironment *queryEnv,
 				   DestReceiver *dest,
-				   QueryCompletion *qc)
+				   QueryCompletion *qc,
+				   Oid namespaceIdWhenCreatingInModule,
+				   Oid moduleIdWhenCreatingInModule)
 {
 	Node	   *parsetree = pstmt->utilityStmt;
 	bool		isTopLevel = (context == PROCESS_UTILITY_TOPLEVEL);
@@ -1130,6 +1227,18 @@ ProcessUtilitySlow(ParseState *pstate,
 				commandCollected = true;
 				break;
 
+			case T_CreateModuleStmt:	/* CREATE Module */
+				CreateModuleCommand((CreateModuleStmt *) parsetree,
+									queryString,
+									pstmt->stmt_location,
+									pstmt->stmt_len);
+				/*
+				 * EventTriggerCollectSimpleCommand called by
+				 * CreateModuleCommand
+				 */
+				commandCollected = true;
+				break;
+
 			case T_CreateStmt:
 			case T_CreateForeignTableStmt:
 				{
@@ -1265,6 +1374,14 @@ ProcessUtilitySlow(ParseState *pstate,
 				}
 				break;
 
+			case T_AlterModuleCreateReplaceFuncStmt:
+				AlterModuleCreateReplaceFunction((AlterModuleCreateReplaceFuncStmt *) parsetree,
+									queryString,
+									pstmt->stmt_location,
+									pstmt->stmt_len);
+				break;
+
+
 			case T_AlterTableStmt:
 				{
 					AlterTableStmt *atstmt = (AlterTableStmt *) parsetree;
@@ -1638,13 +1755,22 @@ ProcessUtilitySlow(ParseState *pstate,
 				break;
 
 			case T_CreateFunctionStmt:	/* CREATE FUNCTION */
-				address = CreateFunction(pstate, (CreateFunctionStmt *) parsetree);
+				if (OidIsValid(moduleIdWhenCreatingInModule))
+					address = CreateFunctionInModule(pstate, (CreateFunctionStmt *) parsetree,
+													 namespaceIdWhenCreatingInModule,
+													 moduleIdWhenCreatingInModule);
+				else
+					address = CreateFunction(pstate, (CreateFunctionStmt *) parsetree);
 				break;
 
 			case T_AlterFunctionStmt:	/* ALTER FUNCTION */
 				address = AlterFunction(pstate, (AlterFunctionStmt *) parsetree);
 				break;
 
+			case T_AlterModuleAlterFuncStmt: /* ALTER MODULE CONTENTS */
+				address = AlterModuleAlterFunction(pstate, (AlterModuleAlterFuncStmt *) parsetree);
+				break;
+
 			case T_RuleStmt:	/* CREATE RULE */
 				address = DefineRule((RuleStmt *) parsetree, queryString);
 				break;
@@ -1757,6 +1883,10 @@ ProcessUtilitySlow(ParseState *pstate,
 				address = ExecRenameStmt((RenameStmt *) parsetree);
 				break;
 
+			case T_AlterModuleRenameStmt:
+				address = AlterModuleRename((AlterModuleRenameStmt *) parsetree);
+				break;
+
 			case T_AlterObjectDependsStmt:
 				address =
 					ExecAlterObjectDependsStmt((AlterObjectDependsStmt *) parsetree,
@@ -1773,6 +1903,10 @@ ProcessUtilitySlow(ParseState *pstate,
 				address = ExecAlterOwnerStmt((AlterOwnerStmt *) parsetree);
 				break;
 
+			case T_AlterModuleOwnerStmt:
+				address = AlterModuleOwner((AlterModuleOwnerStmt *) parsetree);
+				break;
+
 			case T_AlterOperatorStmt:
 				address = AlterOperator((AlterOperatorStmt *) parsetree);
 				break;
@@ -2621,6 +2755,9 @@ CreateCommandTag(Node *parsetree)
 				case OBJECT_STATISTIC_EXT:
 					tag = CMDTAG_DROP_STATISTICS;
 					break;
+				case OBJECT_MODULE:
+					tag = CMDTAG_DROP_MODULE;
+					break;
 				default:
 					tag = CMDTAG_UNKNOWN;
 			}
@@ -2642,6 +2779,22 @@ CreateCommandTag(Node *parsetree)
 			tag = CMDTAG_COPY;
 			break;
 
+		case T_AlterModuleRenameStmt:
+			tag = CMDTAG_ALTER_MODULE_RENAME;
+			break;
+
+		case T_AlterModuleOwnerStmt:
+			tag = CMDTAG_ALTER_MODULE_OWNER;
+			break;
+
+		case T_AlterModuleCreateReplaceFuncStmt:
+			tag = CMDTAG_ALTER_MODULE_CREATE_REPLACE_FUNC;
+			break;
+
+		case T_AlterModuleAlterFuncStmt:
+			tag = CMDTAG_ALTER_MODULE_ALTER_FUNCTION;
+			break;
+
 		case T_RenameStmt:
 
 			/*
@@ -2776,6 +2929,10 @@ CreateCommandTag(Node *parsetree)
 				tag = CMDTAG_CREATE_FUNCTION;
 			break;
 
+		case T_CreateModuleStmt:
+			tag = CMDTAG_CREATE_MODULE;
+			break;
+
 		case T_IndexStmt:
 			tag = CMDTAG_CREATE_INDEX;
 			break;
@@ -3419,6 +3576,10 @@ GetCommandLogLevel(Node *parsetree)
 			lev = LOGSTMT_DDL;
 			break;
 
+		case T_CreateModuleStmt:
+			lev = LOGSTMT_DDL;
+			break;
+
 		case T_IndexStmt:
 			lev = LOGSTMT_DDL;
 			break;
diff --git a/src/backend/utils/adt/acl.c b/src/backend/utils/adt/acl.c
index 0a16f8156c..05d9e023d6 100644
--- a/src/backend/utils/adt/acl.c
+++ b/src/backend/utils/adt/acl.c
@@ -773,6 +773,10 @@ acldefault(ObjectType objtype, Oid ownerId)
 			world_default = ACL_NO_RIGHTS;
 			owner_default = ACL_ALL_RIGHTS_LARGEOBJECT;
 			break;
+		case OBJECT_MODULE:
+			world_default = ACL_NO_RIGHTS;
+			owner_default = ACL_ALL_RIGHTS_MODULE;
+			break;
 		case OBJECT_SCHEMA:
 			world_default = ACL_NO_RIGHTS;
 			owner_default = ACL_ALL_RIGHTS_SCHEMA;
diff --git a/src/backend/utils/cache/lsyscache.c b/src/backend/utils/cache/lsyscache.c
index feef999863..b46e064a44 100644
--- a/src/backend/utils/cache/lsyscache.c
+++ b/src/backend/utils/cache/lsyscache.c
@@ -27,6 +27,7 @@
 #include "catalog/pg_collation.h"
 #include "catalog/pg_constraint.h"
 #include "catalog/pg_language.h"
+#include "catalog/pg_module.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_opclass.h"
 #include "catalog/pg_operator.h"
@@ -3304,6 +3305,31 @@ free_attstatsslot(AttStatsSlot *sslot)
 		pfree(sslot->numbers_arr);
 }
 
+/*				---------- PG_MODULE CACHE ----------				 */
+
+/*
+ * get_module_name
+ *		Returns the name of a given module or NULL if no such module
+ */
+char *
+get_module_name(Oid modid)
+{
+	HeapTuple	tp;
+
+	tp = SearchSysCache1(MODULEOID, ObjectIdGetDatum(modid));
+	if (HeapTupleIsValid(tp))
+	{
+		Form_pg_module modtup = (Form_pg_module) GETSTRUCT(tp);
+		char	   *result;
+
+		result = pstrdup(NameStr(modtup->modname));
+		ReleaseSysCache(tp);
+		return result;
+	}
+	else
+		return NULL;
+}
+
 /*				---------- PG_NAMESPACE CACHE ----------				 */
 
 /*
diff --git a/src/backend/utils/cache/syscache.c b/src/backend/utils/cache/syscache.c
index f4e7819f1e..bf1db809af 100644
--- a/src/backend/utils/cache/syscache.c
+++ b/src/backend/utils/cache/syscache.c
@@ -43,6 +43,7 @@
 #include "catalog/pg_foreign_server.h"
 #include "catalog/pg_foreign_table.h"
 #include "catalog/pg_language.h"
+#include "catalog/pg_module.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_opclass.h"
 #include "catalog/pg_operator.h"
@@ -508,6 +509,28 @@ static const struct cachedesc cacheinfo[] = {
 		},
 		4
 	},
+	{ModuleRelationId,		/* MODULENAME */
+		ModuleNameIndexId,
+		2,
+		{
+			Anum_pg_module_modname,
+			Anum_pg_module_nspoid,
+			0,
+			0
+		},
+		16
+	},
+	{ModuleRelationId,		/* MODULEOID */
+		ModuleOidIndexId,
+		1,
+		{
+			Anum_pg_module_oid,
+			0,
+			0,
+			0
+		},
+		16
+	},
 	{NamespaceRelationId,		/* NAMESPACENAME */
 		NamespaceNameIndexId,
 		1,
@@ -586,13 +609,13 @@ static const struct cachedesc cacheinfo[] = {
 		32
 	},
 	{ProcedureRelationId,		/* PROCNAMEARGSNSP */
-		ProcedureNameArgsNspIndexId,
-		3,
+		ProcedureNameArgsNspModIndexId,
+		4,
 		{
 			Anum_pg_proc_proname,
 			Anum_pg_proc_proargtypes,
 			Anum_pg_proc_pronamespace,
-			0
+			Anum_pg_proc_promodule
 		},
 		128
 	},
@@ -1268,13 +1291,18 @@ GetSysCacheOid(int cacheId,
 	Oid			result;
 
 	tuple = SearchSysCache(cacheId, key1, key2, key3, key4);
+
 	if (!HeapTupleIsValid(tuple))
 		return InvalidOid;
+
 	result = heap_getattr(tuple, oidcol,
 						  SysCache[cacheId]->cc_tupdesc,
 						  &isNull);
+
 	Assert(!isNull);			/* columns used as oids should never be NULL */
+
 	ReleaseSysCache(tuple);
+
 	return result;
 }
 
diff --git a/src/bin/pg_dump/common.c b/src/bin/pg_dump/common.c
index b9a25442f5..83fef4108e 100644
--- a/src/bin/pg_dump/common.c
+++ b/src/bin/pg_dump/common.c
@@ -21,6 +21,7 @@
 #include "catalog/pg_collation_d.h"
 #include "catalog/pg_extension_d.h"
 #include "catalog/pg_namespace_d.h"
+#include "catalog/pg_module_d.h"
 #include "catalog/pg_operator_d.h"
 #include "catalog/pg_proc_d.h"
 #include "catalog/pg_publication_d.h"
@@ -105,6 +106,7 @@ getSchemaData(Archive *fout, int *numTablesPtr)
 	int			numOperators;
 	int			numCollations;
 	int			numNamespaces;
+	int			numModules;
 	int			numExtensions;
 	int			numPublications;
 	int			numAggregates;
@@ -151,6 +153,9 @@ getSchemaData(Archive *fout, int *numTablesPtr)
 
 	getOwnedSeqs(fout, tblinfo, numTables);
 
+	pg_log_info("reading modules");
+	(void) getModules(fout, &numModules);
+
 	pg_log_info("reading user-defined functions");
 	(void) getFuncs(fout, &numFuncs);
 
@@ -885,6 +890,24 @@ findNamespaceByOid(Oid oid)
 	return (NamespaceInfo *) dobj;
 }
 
+/*
+ * findModuleByOid
+ *	  finds the DumpableObject for the module with the given oid
+ *	  returns NULL if not found
+ */
+ModuleInfo *
+findModuleByOid(Oid oid)
+{
+	CatalogId	catId;
+	DumpableObject *dobj;
+
+	catId.tableoid = ModuleRelationId;
+	catId.oid = oid;
+	dobj = findObjectByCatalogId(catId);
+	Assert(dobj == NULL || dobj->objType == DO_MODULE);
+	return (ModuleInfo *) dobj;
+}
+
 /*
  * findExtensionByOid
  *	  finds the DumpableObject for the extension with the given oid
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index e3ddf19959..381297376c 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -202,6 +202,7 @@ static int	findSecLabels(Oid classoid, Oid objoid, SecLabelItem **items);
 static void collectSecLabels(Archive *fout);
 static void dumpDumpableObject(Archive *fout, DumpableObject *dobj);
 static void dumpNamespace(Archive *fout, const NamespaceInfo *nspinfo);
+static void dumpModule(Archive *fout, const ModuleInfo *modinfo);
 static void dumpExtension(Archive *fout, const ExtensionInfo *extinfo);
 static void dumpType(Archive *fout, const TypeInfo *tyinfo);
 static void dumpBaseType(Archive *fout, const TypeInfo *tyinfo);
@@ -4907,6 +4908,85 @@ getNamespaces(Archive *fout, int *numNamespaces)
 	return nsinfo;
 }
 
+/*
+ * getModules:
+ *	read all modulees in the system catalogs and return them in the
+ * ModuleInfo* structure
+ *
+ *	numModules is set to the number of moduless read in
+ */
+ModuleInfo *
+getModules(Archive *fout, int *numModules)
+{
+	PGresult *res;
+	int ntups;
+	int	i;
+	PQExpBuffer query;
+	ModuleInfo *modinfo;
+	int i_oid;
+	int i_modname;
+	int i_nspoid;
+	int i_modowner;
+	int i_modacl;
+	int i_acldefault;
+
+	query = createPQExpBuffer();
+
+	/*
+	 * we fetch all modules in pg_module
+	 */
+	appendPQExpBuffer(query, "SELECT n.oid, n.modname, "
+					  "n.nspoid, "
+					  "n.modowner, "
+					  "n.modacl, "
+					  "acldefault('n', n.modowner) AS acldefault "
+					  "FROM pg_module n");
+
+	res = ExecuteSqlQuery(fout, query->data, PGRES_TUPLES_OK);
+
+	ntups = PQntuples(res);
+
+	modinfo = (ModuleInfo *) pg_malloc(ntups * sizeof(ModuleInfo));
+
+	i_oid = PQfnumber(res, "oid");
+	i_modname = PQfnumber(res, "modname");
+	i_nspoid = PQfnumber(res, "nspoid");
+	i_modowner = PQfnumber(res, "modowner");
+	i_modacl = PQfnumber(res, "modacl");
+	i_acldefault = PQfnumber(res, "acldefault");
+
+	for (i = 0; i < ntups; i++)
+	{
+		const char *modowner;
+		const char *nspoid;
+
+		modinfo[i].dobj.objType = DO_MODULE;
+		modinfo[i].dobj.catId.oid = atooid(PQgetvalue(res, i, i_oid));
+		AssignDumpId(&modinfo[i].dobj);
+		modinfo[i].dobj.name = pg_strdup(PQgetvalue(res, i, i_modname));
+		modinfo[i].dacl.acl = pg_strdup(PQgetvalue(res, i, i_modacl));
+		modinfo[i].dacl.acldefault = pg_strdup(PQgetvalue(res, i, i_acldefault));
+		modinfo[i].dacl.privtype = 0;
+		modinfo[i].dacl.initprivs = NULL;
+		nspoid = PQgetvalue(res, i, i_nspoid);
+		modinfo[i].nspoid = atooid(nspoid);
+		modowner = PQgetvalue(res, i, i_modowner);
+		modinfo[i].modowner = atooid(modowner);
+		modinfo[i].rolname = getRoleName(modowner);
+
+		/* Mark whether module has an ACL */
+		if (!PQgetisnull(res, i, i_modacl))
+			modinfo[i].dobj.components |= DUMP_COMPONENT_ACL;
+	}
+
+	PQclear(res);
+	destroyPQExpBuffer(query);
+
+	*numModules = ntups;
+
+	return modinfo;
+}
+
 /*
  * findNamespace:
  *		given a namespace OID, look up the info read by getNamespaces
@@ -4922,6 +5002,21 @@ findNamespace(Oid nsoid)
 	return nsinfo;
 }
 
+/*
+ * findModule:
+ *		given a module OID, look up the info read by getModules
+ */
+static ModuleInfo *
+findModule(Oid modoid)
+{
+	ModuleInfo *modinfo;
+
+	modinfo = findModuleByOid(modoid);
+	if (modinfo == NULL)
+		fatal("module with OID %u does not exist", modoid);
+	return modinfo;
+}
+
 /*
  * getExtensions:
  *	  read all extensions in the system catalogs and return them in the
@@ -5748,6 +5843,7 @@ getFuncs(Archive *fout, int *numFuncs)
 	int			i_oid;
 	int			i_proname;
 	int			i_pronamespace;
+	int			i_promodule;
 	int			i_proowner;
 	int			i_prolang;
 	int			i_pronargs;
@@ -5790,6 +5886,7 @@ getFuncs(Archive *fout, int *numFuncs)
 						  "p.proacl, "
 						  "acldefault('f', p.proowner) AS acldefault, "
 						  "p.pronamespace, "
+						  "p.pronmodule, "
 						  "p.proowner "
 						  "FROM pg_proc p "
 						  "LEFT JOIN pg_init_privs pip ON "
@@ -5832,6 +5929,7 @@ getFuncs(Archive *fout, int *numFuncs)
 						  "pronargs, proargtypes, prorettype, proacl, "
 						  "acldefault('f', proowner) AS acldefault, "
 						  "pronamespace, "
+						  "promodule, "
 						  "proowner "
 						  "FROM pg_proc p "
 						  "WHERE NOT proisagg"
@@ -5877,6 +5975,7 @@ getFuncs(Archive *fout, int *numFuncs)
 	i_oid = PQfnumber(res, "oid");
 	i_proname = PQfnumber(res, "proname");
 	i_pronamespace = PQfnumber(res, "pronamespace");
+	i_promodule = PQfnumber(res, "promodule");
 	i_proowner = PQfnumber(res, "proowner");
 	i_prolang = PQfnumber(res, "prolang");
 	i_pronargs = PQfnumber(res, "pronargs");
@@ -5894,6 +5993,8 @@ getFuncs(Archive *fout, int *numFuncs)
 		finfo[i].dobj.name = pg_strdup(PQgetvalue(res, i, i_proname));
 		finfo[i].dobj.namespace =
 			findNamespace(atooid(PQgetvalue(res, i, i_pronamespace)));
+		finfo[i].dobj.module =
+			findModule(atooid(PQgetvalue(res, i, i_promodule)));
 		finfo[i].dacl.acl = pg_strdup(PQgetvalue(res, i, i_proacl));
 		finfo[i].dacl.acldefault = pg_strdup(PQgetvalue(res, i, i_acldefault));
 		finfo[i].dacl.privtype = 0;
@@ -9615,6 +9716,9 @@ dumpDumpableObject(Archive *fout, DumpableObject *dobj)
 		case DO_NAMESPACE:
 			dumpNamespace(fout, (const NamespaceInfo *) dobj);
 			break;
+		case DO_MODULE:
+			dumpModule(fout, (const ModuleInfo *) dobj);
+			break;
 		case DO_EXTENSION:
 			dumpExtension(fout, (const ExtensionInfo *) dobj);
 			break;
@@ -9853,6 +9957,44 @@ dumpNamespace(Archive *fout, const NamespaceInfo *nspinfo)
 	destroyPQExpBuffer(delq);
 }
 
+/*
+ * dumpModule
+ *	  writes out to fout the queries to recreate a user-defined module
+ *	  Functions and procedures will be added to the module when those
+ *	  functions and procedures are created, with ALTER MODULE.
+ */
+static void
+dumpModule(Archive *fout, const ModuleInfo *modinfo)
+{
+	DumpOptions *dopt = fout->dopt;
+	PQExpBuffer q;
+	PQExpBuffer delq;
+	char	   *qmodname;
+
+	/* Do nothing in data-only dump */
+	if (dopt->dataOnly)
+		return;
+
+	q = createPQExpBuffer();
+	delq = createPQExpBuffer();
+
+	qmodname = pg_strdup(fmtId(modinfo->dobj.name));
+
+	appendPQExpBuffer(delq, "DROP IF EXISTS MODULE %s;\n", qmodname);
+	appendPQExpBuffer(q, "CREATE MODULE %s;\n", qmodname);
+
+
+	if (modinfo->dobj.dump & DUMP_COMPONENT_ACL)
+		dumpACL(fout, modinfo->dobj.dumpId, InvalidDumpId, "MODULE",
+				qmodname, NULL, NULL,
+				modinfo->rolname, &modinfo->dacl);
+
+	free(qmodname);
+
+	destroyPQExpBuffer(q);
+	destroyPQExpBuffer(delq);
+}
+
 /*
  * dumpExtension
  *	  writes out to fout the queries to recreate an extension
@@ -11539,11 +11681,23 @@ dumpFunc(Archive *fout, const FuncInfo *finfo)
 	appendPQExpBuffer(delqry, "DROP %s %s;\n",
 					  keyword, qual_funcsig);
 
-	appendPQExpBuffer(q, "CREATE %s %s.%s",
-					  keyword,
-					  fmtId(finfo->dobj.namespace->dobj.name),
-					  funcfullsig ? funcfullsig :
-					  funcsig);
+	if (finfo->dobj.module == NULL)
+	{
+		appendPQExpBuffer(q, "CREATE %s %s.%s",
+						  keyword,
+						  fmtId(finfo->dobj.namespace->dobj.name),
+						  funcfullsig ? funcfullsig :
+						  funcsig);
+	}
+	else
+	{
+		appendPQExpBuffer(q, "ALTER MODULE %s CREATE %s %s.%s",
+						  fmtId(finfo->dobj.module->dobj.name),
+						  keyword,
+						  fmtId(finfo->dobj.namespace->dobj.name),
+						  funcfullsig ? funcfullsig :
+						  funcsig);
+	}
 
 	if (prokind[0] == PROKIND_PROCEDURE)
 		 /* no result type to output */ ;
@@ -17647,6 +17801,7 @@ addBoundaryDependencies(DumpableObject **dobjs, int numObjs,
 		switch (dobj->objType)
 		{
 			case DO_NAMESPACE:
+			case DO_MODULE:
 			case DO_EXTENSION:
 			case DO_TYPE:
 			case DO_SHELL_TYPE:
diff --git a/src/bin/pg_dump/pg_dump.h b/src/bin/pg_dump/pg_dump.h
index 066a129ee5..4516a11a5a 100644
--- a/src/bin/pg_dump/pg_dump.h
+++ b/src/bin/pg_dump/pg_dump.h
@@ -82,7 +82,8 @@ typedef enum
 	DO_PUBLICATION,
 	DO_PUBLICATION_REL,
 	DO_PUBLICATION_TABLE_IN_SCHEMA,
-	DO_SUBSCRIPTION
+	DO_SUBSCRIPTION,
+	DO_MODULE
 } DumpableObjectType;
 
 /*
@@ -136,6 +137,7 @@ typedef struct _dumpableObject
 	DumpId		dumpId;			/* assigned by AssignDumpId() */
 	char	   *name;			/* object name (should never be NULL) */
 	struct _namespaceInfo *namespace;	/* containing namespace, or NULL */
+	struct _moduleInfo *module;	/* containing module, or NULL */
 	DumpComponents dump;		/* bitmask of components requested to dump */
 	DumpComponents dump_contains;	/* as above, but for contained objects */
 	DumpComponents components;	/* bitmask of components available to dump */
@@ -175,6 +177,16 @@ typedef struct _namespaceInfo
 	const char *rolname;		/* name of owner */
 } NamespaceInfo;
 
+typedef struct _moduleInfo
+{
+	DumpableObject dobj;
+	DumpableAcl dacl;
+	bool		create;			/* CREATE MODULE, or just set owner? */
+	Oid			nspoid; 		/* OID of schema */
+	Oid			modowner;		/* OID of owner */
+	const char *rolname;		/* name of owner */
+} ModuleInfo;
+
 typedef struct _extensionInfo
 {
 	DumpableObject dobj;
@@ -681,6 +693,7 @@ extern FuncInfo *findFuncByOid(Oid oid);
 extern OprInfo *findOprByOid(Oid oid);
 extern CollInfo *findCollationByOid(Oid oid);
 extern NamespaceInfo *findNamespaceByOid(Oid oid);
+extern ModuleInfo *findModuleByOid(Oid oid);
 extern ExtensionInfo *findExtensionByOid(Oid oid);
 extern PublicationInfo *findPublicationByOid(Oid oid);
 
@@ -697,6 +710,7 @@ extern void sortDumpableObjectsByTypeName(DumpableObject **objs, int numObjs);
  * version specific routines
  */
 extern NamespaceInfo *getNamespaces(Archive *fout, int *numNamespaces);
+extern ModuleInfo *getModules(Archive *fout, int *numModules);
 extern ExtensionInfo *getExtensions(Archive *fout, int *numExtensions);
 extern TypeInfo *getTypes(Archive *fout, int *numTypes);
 extern FuncInfo *getFuncs(Archive *fout, int *numFuncs);
diff --git a/src/bin/pg_dump/pg_dump_sort.c b/src/bin/pg_dump/pg_dump_sort.c
index d979f93b3d..0a10a6a18b 100644
--- a/src/bin/pg_dump/pg_dump_sort.c
+++ b/src/bin/pg_dump/pg_dump_sort.c
@@ -1277,6 +1277,11 @@ describeDumpableObject(DumpableObject *obj, char *buf, int bufsize)
 					 "SCHEMA %s  (ID %d OID %u)",
 					 obj->name, obj->dumpId, obj->catId.oid);
 			return;
+		case DO_MODULE:
+			snprintf(buf, bufsize,
+					 "MODULE %s  (ID %d OID %u)",
+					 obj->name, obj->dumpId, obj->catId.oid);
+			return;
 		case DO_EXTENSION:
 			snprintf(buf, bufsize,
 					 "EXTENSION %s  (ID %d OID %u)",
diff --git a/src/include/catalog/catversion.h b/src/include/catalog/catversion.h
index 6487bf9c0a..576ab7d802 100644
--- a/src/include/catalog/catversion.h
+++ b/src/include/catalog/catversion.h
@@ -53,6 +53,7 @@
  */
 
 /*							yyyymmddN */
-#define CATALOG_VERSION_NO	202201311
+
+#define CATALOG_VERSION_NO	202202021
 
 #endif
diff --git a/src/include/catalog/dependency.h b/src/include/catalog/dependency.h
index 344482ec87..f47fd681bc 100644
--- a/src/include/catalog/dependency.h
+++ b/src/include/catalog/dependency.h
@@ -105,6 +105,7 @@ typedef enum ObjectClass
 	OCLASS_AMPROC,				/* pg_amproc */
 	OCLASS_REWRITE,				/* pg_rewrite */
 	OCLASS_TRIGGER,				/* pg_trigger */
+	OCLASS_MODULE,				/* pg_module */
 	OCLASS_SCHEMA,				/* pg_namespace */
 	OCLASS_STATISTIC_EXT,		/* pg_statistic_ext */
 	OCLASS_TSPARSER,			/* pg_ts_parser */
diff --git a/src/include/catalog/namespace.h b/src/include/catalog/namespace.h
index f963d82797..a405247fb6 100644
--- a/src/include/catalog/namespace.h
+++ b/src/include/catalog/namespace.h
@@ -136,16 +136,23 @@ extern bool TSTemplateIsVisible(Oid tmplId);
 extern Oid	get_ts_config_oid(List *names, bool missing_ok);
 extern bool TSConfigIsVisible(Oid cfgid);
 
-extern void DeconstructQualifiedName(List *names,
-									 char **nspname_p,
-									 char **objname_p);
+extern void DeconstructQualifiedNameNoModule(List *names,
+											char **nspname_p,
+											char **objname_p);
+extern void DeconstructQualifiedNameWithModule(List *names,
+											char **nspname_p,
+											char **modname_p,
+											char **objname_p);
 extern Oid	LookupNamespaceNoError(const char *nspname);
 extern Oid	LookupExplicitNamespace(const char *nspname, bool missing_ok);
 extern Oid	get_namespace_oid(const char *nspname, bool missing_ok);
+extern Oid	get_module_oid(List *names, bool missing_ok);
+extern Oid	get_module_oid_from_name(Oid nspoid, const char *modname, bool missing_ok);
 
 extern Oid	LookupCreationNamespace(const char *nspname);
 extern void CheckSetNamespace(Oid oldNspOid, Oid nspOid);
 extern Oid	QualifiedNameGetCreationNamespace(List *names, char **objname_p);
+extern Oid	QualifiedNameWithModuleGetCreationNamespace(List *names, Oid *moduleId, char **objname_p);
 extern RangeVar *makeRangeVarFromNameList(List *names);
 extern char *NameListToString(List *names);
 extern char *NameListToQuotedString(List *names);
